var values = {
    run_loop : false,
    counter : 0,
    port_open  : false,
    key_type : "crypto1"
} 

var DlComands = {
    OPEN_PORT : "OPEN_PORT",
    CLOSE_PORT : "CLOSE_PORT",
    GET_CARD_ID_LAST_EX : "GET_CARD_ID_LAST_EX",
    GET_CARD_ID_EX : "GET_CARD_ID_EX",
    GET_DLOGIC_CARD_TYPE : "GET_DLOGIC_CARD_TYPE",
    READER_UI_SIGNAL : "READER_UI_SIGNAL",
    BLOCK_READ_PK : "BLOCK_READ_PK",
    BLOCK_WRITE_PK : "BLOCK_WRITE_PK",
    READER_KEY_WRITE : "READER_KEY_WRITE",
    WRITE_CARD_ACCESS: "WRITE_CARD_ACCESS",
    CARD_KEY_WRITE : "CARD_KEY_WRITE"
}

var DL_OK = 0;

function printUid(arg){
     try {
     data = JSON.parse(arg)

     } catch (e) {
         data = rawResponseToObject(arg);
      }


      if(data.dlStatus == DL_OK){
       document.getElementById("card_uid_box").value = data.data;
     }else{
     document.getElementById("card_uid_box").value = "";
     }

}

function rawResponseToObject(arg){

  var temp = arg.split(',');

  var res = {

     dlStatus : temp[0].split('=')[1],
     dlMsg : temp[1].split('=')[1],
     dlCommand : temp[2].split('=')[1],
     data : temp[3].split('=')[1],
  }
  return res;

}

function clearResponseDisplay(){
    document.getElementById("res_disp").value = "";
}

function print(arg,disp_uid){

     if( document.getElementById("append_to_disp").checked == "1"){
        document.getElementById("res_disp").value =   document.getElementById("res_disp").value + "\n" + arg;
     }else{
        document.getElementById("res_disp").value = arg;
     }


    if(disp_uid){
        printUid(arg);
    }
}

function GetXmlHttpObject() {
    var xmlHttp=null;
    try {
        xmlHttp=new XMLHttpRequest();
    } catch (e) {
        try {
            xmlHttp=new ActiveXObject("Msxml2.XMLHTTP");
        } catch (e) {
            xmlHttp=new ActiveXObject("Microsoft.XMLHTTP");
        }
    }
    return xmlHttp;
}


function doAjax(param,disp_uid,callback){
    
    var url =  document.getElementById("server_url").value;
    
    var xmlHttp = GetXmlHttpObject();
    xmlHttp.open("POST", url, true);
    xmlHttp.responseType = 'text';
    xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
    xmlHttp.onreadystatechange = function (oEvent) {
    if (xmlHttp.readyState === 4) {
        if (xmlHttp.status === 200) {
             print(this.response,disp_uid);
             console.log(this.response);
             if(callback != null && callback != undefined){
                callback(this.response);
             }
        } else {
           alert("Ajax Error" + xmlHttp.responseText + ". Please check if your SERVER is running.");
        }
      }
    }

    xmlHttp.send("uFrFunct=" +param );
    
}

function startLoop(){
    console.log("startLoop")
    values.run_loop = true;
    setInterval(function(){
        
         values.counter++;
        
        if(values.run_loop){
           console.log("run loop -> " +  values.counter);
            
            doAjax(DlComands.GET_CARD_ID_LAST_EX,true);
            
            
        }else{
          // console.log("skip loop -> " + values.counter);  
        }
        
    }, 300);
}


function stopLoop(){
     console.log("stopLoop")
     values.run_loop = false;
}

function openPort(){
      console.log("openPort")
      doAjax(DlComands.OPEN_PORT,false,function(res){
       data = rawResponseToObject(res);
       document.getElementById("dl_status").value = data.dlMsg;

    });
}

function closePort(){
      console.log("closePort")
      doAjax(DlComands.CLOSE_PORT,false,function(res){
       data = rawResponseToObject(res);
       document.getElementById("dl_status").value = data.dlMsg;

    });
}

function getCardIdEx(){
    if(values.run_loop){
         alert("Please first pause loop!");
         return;
     }
    
     console.log("getCardIdEx")
     doAjax(DlComands.GET_CARD_ID_EX,true,function(res){
       data = rawResponseToObject(res);
       document.getElementById("dl_status").value = data.dlMsg;

    });
}

function UIsignal(){
      if(values.run_loop){
         alert("Please first pause loop!");
         return;
     }
    
     console.log("UIsignal")
     var sound = document.getElementById("sound_mode").value;
     var light = document.getElementById("light_mode").value;
     var param = DlComands.READER_UI_SIGNAL + "&iSoundMode="+ sound + "&iLightMode=" + light;
     
     doAjax(param,false,function(res){
       data = rawResponseToObject(res);
       document.getElementById("dl_status").value = data.dlMsg;

    });
}

function BlockReadPK(){

    if(values.run_loop){
         alert("Please first pause loop!");
         return;
   }

   var authMode = document.getElementById("block_read_auth_mode").value;
   var key1 = document.getElementById("block_read_key1").value;
   var key2 = document.getElementById("block_read_key2").value;
   var key3 = document.getElementById("block_read_key3").value;
   var key4 = document.getElementById("block_read_key4").value;
   var key5 = document.getElementById("block_read_key5").value;
   var key6 = document.getElementById("block_read_key6").value;
   var block_address = document.getElementById("block_read_address").value;

    var param = DlComands.BLOCK_READ_PK + "&authMode=" + authMode + "&blockAddress=" + block_address;
    param +=  "&key1=" +  key1;
    param +=  "&key2=" +  key2;
    param +=  "&key3=" +  key3;
    param +=  "&key4=" +  key4;
    param +=  "&key5=" +  key5;
    param +=  "&key6=" +  key6;

    doAjax(param,false,function(res){
       data = rawResponseToObject(res);
       document.getElementById("dl_status").value = data.dlMsg;
       
       if (values.key_type == "ultralight"){ 
       var block_data = splitAtEvery(data.data).join(" ");
        document.getElementById("block_read_result").value = block_data.slice(0, 11);
       } else {
        document.getElementById("block_read_result").value = splitAtEvery(data.data).join(" ");
       }
    });
}


function BlockWritePK(){

   if(values.run_loop){
         alert("Please first pause loop!");
         return;
   }

   var authMode = document.getElementById("block_write_auth_mode").value;
   var key1 = document.getElementById("block_write_key1").value;
   var key2 = document.getElementById("block_write_key2").value;
   var key3 = document.getElementById("block_write_key3").value;
   var key4 = document.getElementById("block_write_key4").value;
   var key5 = document.getElementById("block_write_key5").value;
   var key6 = document.getElementById("block_write_key6").value;
   var block_address = document.getElementById("block_write_address").value;
   var block_write_data = document.getElementById("block_write_data").value;


var param = DlComands.BLOCK_WRITE_PK + "&authMode=" + authMode + "&blockAddress=" + block_address + "&data=" + block_write_data;
    param +=  "&key1=" +  key1;
    param +=  "&key2=" +  key2;
    param +=  "&key3=" +  key3;
    param +=  "&key4=" +  key4;
    param +=  "&key5=" +  key5;
    param +=  "&key6=" +  key6;

    doAjax(param,false,function(res){
       data = rawResponseToObject(res);
       document.getElementById("dl_status").value = data.dlMsg;

    });
}



function hexToBytes(hex) {
    for (var bytes = [], c = 0; c < hex.length; c += 2)
    bytes.push(parseInt(hex.substr(c, 2), 16));
    return bytes;
}

function splitAtEvery(hex){
  var arr = [];
  for(var i =0; i < hex.length; i += 2 ){
     arr.push(hex.substr(i, 2));
  }
  return arr;
}

function parseHexString(str) {
    var result = [];
    while (str.length >= 8) {
        result.push(parseInt(str.substring(0, 8), 16));

        str = str.substring(8, str.length);
    }
    return result;
}


function getDlogicCardType(){
    if(values.run_loop){
         alert("Please first pause loop!");
         return;
     }
     console.log("getDlogicCardType")
     doAjax(DlComands.GET_DLOGIC_CARD_TYPE,false, function(res){
        data = rawResponseToObject(res);
        switch(data.data){
            case "1":
            case "2":
            case "3":
            case "8":
            case "9":
            case "10":
                values.key_type = "ultralight"
                break;
            default:
                values.key_type = "crypto1"
        }
        console.log(values.key_type)
        displayAuthOptions();
     });
}

function ReaderKeyWrite(){
    if(values.run_loop){
        alert("Please first pause loop!");
        return;
    }
    var key1 = document.getElementById("new_pwd_key_1").value;
    var key2 = document.getElementById("new_pwd_key_2").value;
    var key3 = document.getElementById("new_pwd_key_3").value;
    var key4 = document.getElementById("new_pwd_key_4").value;
    var key5 = document.getElementById("new_pack_key_1").value;
    var key6 = document.getElementById("new_pack_key_2").value;

    console.log("ReaderKeyWrite")

    var param = DlComands.READER_KEY_WRITE
        param +=  "&key1=" +  key1;
        param +=  "&key2=" +  key2;
        param +=  "&key3=" +  key3;
        param +=  "&key4=" +  key4;
        param +=  "&key5=" +  key5;
        param +=  "&key6=" +  key6; 
        param += "&key_index=" + 0;

    doAjax(param, false, function(res){
        data = rawResponseToObject(res);
       document.getElementById("dl_status").value = data.dlMsg;
    });
}

function WriteCardKey(){

    if(values.run_loop){
        alert("Please first pause loop!");
        return;
    }
    
    console.log("CardkeyWrite")

    var key1 = document.getElementById("pwd_key_1").value;
    var key2 = document.getElementById("pwd_key_2").value;
    var key3 = document.getElementById("pwd_key_3").value;
    var key4 = document.getElementById("pwd_key_4").value;
    var key5 = document.getElementById("pack_key_1").value;
    var key6 = document.getElementById("pack_key_2").value;

    var new_key1 = document.getElementById("new_pwd_key_1").value;
    var new_key2 = document.getElementById("new_pwd_key_2").value;
    var new_key3 = document.getElementById("new_pwd_key_3").value;
    var new_key4 = document.getElementById("new_pwd_key_4").value;
    var new_key5 = document.getElementById("new_pack_key_1").value;
    var new_key6 = document.getElementById("new_pack_key_2").value;
    

    var authMode = document.getElementById("key_write_auth_mode").value;
    var param = DlComands.CARD_KEY_WRITE
    param +=  "&key1=" +  key1;
    param +=  "&key2=" +  key2;
    param +=  "&key3=" +  key3;
    param +=  "&key4=" +  key4;
    param +=  "&key5=" +  key5;
    param +=  "&key6=" +  key6; 
    param +=  "&new_key1=" + new_key1;
    param +=  "&new_key2=" + new_key2;
    param +=  "&new_key3=" + new_key3;
    param +=  "&new_key4=" + new_key4;
    param +=  "&new_key5=" + new_key5;
    param +=  "&new_key6=" + new_key6;
    param += "&authMode=" + authMode;

    doAjax(param, false, function(res){
        data = rawResponseToObject(res);
        document.getElementById("dl_status").value = data.dlMsg;
    });
}


function WriteCardAccess(){

    if(values.run_loop){
        alert("Please first pause loop!");
        return;
    }

    var key1 = document.getElementById("pwd_key_1").value;
    var key2 = document.getElementById("pwd_key_2").value;
    var key3 = document.getElementById("pwd_key_3").value;
    var key4 = document.getElementById("pwd_key_4").value;
    var key5 = document.getElementById("pack_key_1").value;
    var key6 = document.getElementById("pack_key_2").value;

    var authMode = document.getElementById("key_write_auth_mode").value;
    var protection = 0;
    
    var page_protect_address = document.getElementById("protection_address").value;
    var prot_checked = document.querySelector('.read-write-protection:checked').value;
    
    if (prot_checked == null) {
        alert("Select one of the following: no protection, write protection or read/write protection!")
    }

    if (prot_checked == "no-protection"){
        protection = 0;
        page_protect_address = 1234; // dummy number since this param is irrelevant to no-protection
    } else if (prot_checked == "write-protection"){
        protection = 1;
    } else if (prot_checked == "read-write-protection"){
        protection = 2;
    }

    if (page_protect_address  == ""){
        if ((prot_checked === "write-protection") || (prot_checked === "read-write-protection"))
        {
            alert("page protect address must not be null!")
            return;
        }
    }

    var param = DlComands.WRITE_CARD_ACCESS
    param +=  "&key1=" +  key1;
    param +=  "&key2=" +  key2;
    param +=  "&key3=" +  key3;
    param +=  "&key4=" +  key4;
    param +=  "&key5=" +  key5;
    param +=  "&key6=" +  key6;
    param +=  "&protection=" + protection;
    param +=  "&protection_address=" + page_protect_address;
    param +=  "&authMode=" + authMode;

    doAjax(param, false, function(res){
        data = rawResponseToObject(res);
        document.getElementById("dl_status").value = data.dlMsg;
    });

}

function displayAuthOptions(){
    if (values.key_type == "ultralight") {
        document.getElementById("tr_ultralight_auth_options").style.display = "table-row";
        document.getElementById("tr_auth_pwd_pack_key").style.display = "table-row";
        document.getElementById("tr_auth_pwd_key").style.display = "table-row";
        document.getElementById("tr_new_pwd_pack_key").style.display = "table-row";
        document.getElementById("tr_new_pwd_key").style.display = "table-row";
        document.getElementById("tr_key_write_buttons").style.display = "table-row";
        document.getElementById("tr_card_access_header").style.display = "table-row";
        document.getElementById("tr_read_write_protection_options").style.display = "table-row";
        document.getElementById("tr_password_verification_address").style.display = "table-row";
        document.getElementById("tr_card_access_config_button").style.display = "table-row";
        
    } else {
        document.getElementById("tr_ultralight_auth_options").style.display = "none";
        document.getElementById("tr_auth_pwd_pack_key").style.display = "none";
        document.getElementById("tr_auth_pwd_key").style.display = "none";
        document.getElementById("tr_new_pwd_pack_key").style.display = "none";
        document.getElementById("tr_new_pwd_key").style.display = "none";
        document.getElementById("tr_key_write_buttons").style.display = "none";
        document.getElementById("tr_card_access_header").style.display = "none";
        document.getElementById("tr_read_write_protection_options").style.display = "none";
        document.getElementById("tr_password_verification_address").style.display = "none";
        document.getElementById("tr_card_access_config_button").style.display = "none";
    }
}